<?php
/*
 Simple:Press
 Blog Linking - blog post form
 $LastChangedDate: 2011-12-17 10:44:10 -0600 (Sat, 17 Dec 2011) $
 $Rev: 7491 $
 */

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

# ------------------------------------------------------------------
# sp_blog_link_form()
#
# Filter call
# Sets up the forum post linking form in the Post/Page Write screen
# ------------------------------------------------------------------
function sp_blog_link_form() {
         if (function_exists('add_meta_box')) {
                 $sfpostlinking = array();
                 $sfpostlinking = sp_get_option('sfpostlinking');
                 if($sfpostlinking) {
                         foreach($sfpostlinking['posttypes'] as $key=>$value) {
                                 if($value == true) {
                                         add_meta_box('spForumLink', esc_attr(__("Link To Forum", 'sp-linking')), 'sp_populate_post_form', $key, 'advanced');
                                 }
                         }
                 }
         }
}

# ------------------------------------------------------------------
# sp_populate_post_form()
#
# Callback functin to display form in blog post/page panels
# ------------------------------------------------------------------
function sp_populate_post_form() {
         global $SPSTATUS, $post;
         include_once(SPBLLIB.'sp-linking-support.php');

         # can the user do this?
        if(sp_get_auth('create_linked_topics', 'global')==false || $SPSTATUS != 'ok') return;

         $forumid = 0;
         $checked = 'checked="checked"';
         $linkchecked = '';
         $editchecked = '';
         $sfpostlinking = sp_get_option('sfpostlinking');
         if(isset($post->ID)) {
                 $links = sp_blog_links_control('read', $post->ID);
                 if ($links) {
                         $linkchecked = $checked;
                         if ($links->syncedit || $sfpostlinking['sfautoupdate']) $editchecked=$checked;
                         $forumid = $links->forum_id;
                 } else {
                         if ($sfpostlinking['sfautocreate']) {
                                 $linkchecked = 'checked="checked"';
                                 $forumid = $sfpostlinking['sfautoforum'];
                                 if ($sfpostlinking['sfautoupdate']) $editchecked=$checked;
                         }
                 }
         }

         echo '<div id="spf-linking">';
         if (!$links) {
                 # No current link or new
                ?>
                 <p><label for="sflink" class="selectit">
                 <input type="checkbox" <?php echo $linkchecked; ?> name="sflink" id="sflink" />
                 <?php _e("Create forum topic", 'sp-linking'); ?></label><br /><br />
                 <label for="sfforum" class="selectit"><?php esc_attr_e("Select forum:", 'sp-linking'); ?><br />
                 <?php echo sp_blog_links_list($forumid).'</label>';
         } else {
                 # existing link
        $ahahURL = SFHOMEURL."index.php?sp_ahah=linking&amp;sfnonce=".wp_create_nonce('forum-ahah')."&amp;action=breaklink&amp;postid=".$post->ID;
                 $target = 'spf-linking';
                 $confirm = esc_js(__("Are you sure you want to break this link?", 'sp-linking'));
                 echo '<p>'.sprintf(__("This post is linked to the forum %s", 'sp-linking'), '<br /><b>'.spdb_table(SFFORUMS, 'forum_id='.$links->forum_id, 'forum_name')).'</b><br /><br />';
                 echo '<a target="_blank" class="button" href="'.sp_build_url(spdb_table(SFFORUMS, 'forum_id='.$links->forum_id, 'forum_slug'), spdb_table(SFTOPICS, 'topic_id='.$links->topic_id, 'topic_slug'), 1, 0).'">'.__("View Topic in Forum", 'sp-linking').'</a>&nbsp;';
                 echo '<a rel="nofollow" class="button" href="javascript:void(0);" onclick="javascript: if(confirm(\''.$confirm.'\')) {spjBreakBlogLink(\''.$ahahURL.'\', \''.$target.'\');}">'.__("Break Forum Link", 'sp-linking').'</a>';
         }
         ?>
         <br /><br />
         <label for="sfedit" class="selectit">
         <input type="checkbox" <?php echo $editchecked; ?> name="sfedit" id="sfedit" />
         <?php _e("Update forum topic with subsequent edits", 'sp-linking'); ?></label><br /><br />
         <?php
         echo '</p>';
         echo '</div>';
?>
 <script type="text/javascript">
 function spjBreakBlogLink(ahahurl, target)
 {
         jQuery(document).ready(function() {
                 jQuery('#'+target).load(ahahurl);
         });
 }
 </script>
<?php
}

# ------------------------------------------------------------------
# sp_blog_links_list()
#
# Support Routine
# Lists forums for the post write link box
#       $forumid                ID of the forum if already linked (Edit mode)
# ------------------------------------------------------------------
function sp_blog_links_list($forumid) {
         $space = '&nbsp;&nbsp;';
         $groups = sp_get_combined_groups_and_forums_bloglink();
         if ($groups) {
                 $out = '';
                 $out.= '<select id="sfforum" name="sfforum">'."\n";
                 foreach ($groups as $group) {
                         $out.= '<optgroup label="'.sp_create_name_extract(sp_filter_title_display($group['group_name'])).'">'."\n";
                         if ($group['forums']) {
                                 foreach ($group['forums'] as $forum) {
                                         if ($forumid == $forum['forum_id']) {
                                                 $text = 'selected="selected" ';
                                         } else {
                                                 $text = '';
                                         }
                                         $out.='<option '.$text.'value="'.$forum['forum_id'].'">'.$space.sp_create_name_extract(sp_filter_title_display($forum['forum_name'])).'</option>'."\n";
                                 }
                         }
                         $out.='</optgroup>';
                 }
                 $out.='</select>'."\n";
         }
         return $out;
}

?>
