<?php
/*
 Simple:Press
 Blog Linking - general support routines
 $LastChangedDate: 2012-03-24 16:15:39 -0500 (Sat, 24 Mar 2012) $
 $Rev: 8215 $
 */

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

# ------------------------------------------------------------------
# sp_do_move_post_form()
#
# Set blog link id in move post popup (admin tools)
# ------------------------------------------------------------------
function sp_do_move_post_form($postid, $topicid) {
         $postIndex = spdb_table(SFPOSTS, "post_id=$postid", 'post_index');
         $blogPostId = spdb_table(SFTOPICS, "topic_id=$topicid", 'blog_post_id');
         $id = ($postIndex == 1) ? $blogPostId : 0;
         echo "<input type='hidden' name='blogpostid' value='$id' />";
}

# ------------------------------------------------------------------
# sp_do_move_post()
#
# Perform updates in moved post is blog linked
#       $topicid        original topic ID
#       $newtopicid new id if moved post
#       $newforumid new forum id
# ------------------------------------------------------------------
function sp_do_move_post($oldtopicid, $newtopicid, $newforumid) {
         $blogPostId = sp_esc_int($_POST['blogpostid']);
         if($blogPostId) {
                 $sql = 'UPDATE '.SFTOPICS.' SET blog_post_id='.$blogPostId.' WHERE topic_id='.$newtopicid;
                 spdb_query($sql);
                 sp_relink_topic($oldtopicid, $newtopicid, $newforumid);
         }
}

# ------------------------------------------------------------------
# sp_relink_topic()
#
# Relinks topic after a move
# ------------------------------------------------------------------
function sp_relink_topic($topicid, $newtopicid, $newforumid) {
         # Check if the target topic is a linked topic
        $link = spdb_table(SFLINKS, "topic_id=$topicid", 'row');
         if ($link) sp_blog_links_control('update', $link->post_id, $newforumid, $newtopicid, $link->syncedit);
}

# ------------------------------------------------------------------
# sp_do_add_topic_option()
#
# Adds the option to create a blog post from a forum topic to the
# Add New Topic form Options box
# ------------------------------------------------------------------
function sp_do_add_topic_option($optionsBox, $spThisForum) {
         if(sp_get_auth('create_linked_topics', $spThisForum->forum_id) && current_user_can('publish_posts')) {
         $gif = SFCOMMONIMAGES.'working.gif';
                 $site = SFHOMEURL."index.php?sp_ahah=categories&amp;sfnonce=".wp_create_nonce('forum-ahah')."&amp;forum=".$spThisForum->forum_id;
                 $optionsBox.= "<label class='spLabel spCheckbox' for='sfbloglink'>".esc_attr(__("Create and link blog post to this topic", "sp-linking"))."</label>\n";
                 $optionsBox.= "<input type='checkbox' class='spControl' name='bloglink' id='sfbloglink' tabindex='110' onchange='spjGetCategories(\"".$site."\", this.checked, \"".$gif."\")' />\n";
         }       $optionsBox.= "<div id='spCatList'></div>";
         return $optionsBox;
}

# ------------------------------------------------------------------
# sp_break_blog_link()
#
# Breaks the link - removes nothing
#       $topicid        SPF Topic id of the link
#       $postid         WP Post id of the link
# ------------------------------------------------------------------
function sp_break_blog_link($topicid, $postid) {
         global $sfglobals;
         # dont update forum if its locked down
    if ($sfglobals['lockdown']) {
                 sp_notify(1, __('This forum is currently locked and access is read only and therefore cannot be updated', 'sp-linking'));
                 return;
         }

         # remove from postmeta
        sp_blog_links_control('delete', $postid);

         # and set blog_oost_id to zero in topic record
        spdb_query("UPDATE ".SFTOPICS." SET blog_post_id = 0 WHERE topic_id = ".$topicid.";");
}

# ------------------------------------------------------------------
# sp_get_combined_groups_and_forums_bloglink()
#
# Grabs all groups and forums. Soecial cut down version for
# populating the blog link add post drop down
# ------------------------------------------------------------------
function sp_get_combined_groups_and_forums_bloglink() {
         global $sfvars;
         # retrieve group and forum records
        $records = spdb_select('set',
                         "SELECT ".SFGROUPS.".group_id, group_name,
                          forum_id, forum_name
                          FROM ".SFGROUPS."
                          JOIN ".SFFORUMS." ON ".SFGROUPS.".group_id = ".SFFORUMS.".group_id
                          ORDER BY group_seq, forum_seq;");
         # rebuild into an array grabbing permissions on the way
        $groups=array();
         $gindex=-1;
         $findex=0;
         if($records) {
                 foreach($records as $record) {
                         $groupid=$record->group_id;
                         $forumid=$record->forum_id;
                         if (sp_get_auth('create_linked_topics', $forumid) && sp_get_auth('start_topics', $forumid)) {
                                 if($gindex == -1 || $groups[$gindex]['group_id'] != $groupid) {
                                         $gindex++;
                                         $findex=0;
                                         $groups[$gindex]['group_id']=$record->group_id;
                                         $groups[$gindex]['group_name']=$record->group_name;
                                 }
                                 if(isset($record->forum_id)) {
                                         $groups[$gindex]['forums'][$findex]['forum_id']=$record->forum_id;
                                         $groups[$gindex]['forums'][$findex]['forum_name']=$record->forum_name;
                                         $findex++;
                                 }
                         }
                 }
         }
         return $groups;
}

# ------------------------------------------------------------------
# sp_do_canonical_url()
#
# Set canonical url if needed
# ------------------------------------------------------------------
function sp_do_canonical_url($wpPost) {
         global $sfglobals;
         if (!empty($wpPost->ID) && $sfglobals['canonicalurl'] == false) {
                 $sfpostlinking = sp_get_option('sfpostlinking');
                 $topic = sp_blog_links_control('read', $wpPost->ID);
                 if (!empty($topic) && $sfpostlinking['sflinkurls'] == 2) {
                         $forum_slug = spdb_table(SFFORUMS, 'forum_id='.$topic->forum_id, 'forum_slug');
                         $topic_slug = spdb_table(SFTOPICS, 'topic_id='.$topic->topic_id, 'topic_slug');
                         $url = sp_build_url($forum_slug, $topic_slug, 0, 0);
                         echo '<link rel="canonical" href="'.$url.'" />';
                         $sfglobals['canonicalurl'] = true;
                 }
         }
}

# ------------------------------------------------------------------
# sp_do_aioseo_canonical_url()
#
# Set canonical url for aioseo if needed
# ------------------------------------------------------------------
function sp_do_aioseo_canonical_url($url, $wpPost) {
         global $sfglobals;
         if (!empty($wpPost->ID) && $sfglobals['canonicalurl'] == false) {
                 $sfpostlinking = sp_get_option('sfpostlinking');
                 $topic = sp_blog_links_control('read', $wpPost->ID);
                 if (!empty($topic) && $sfpostlinking['sflinkurls'] == 2) {
                         $forum_slug = spdb_table(SFFORUMS, 'forum_id='.$topic->forum_id, 'forum_slug');
                         $topic_slug = spdb_table(SFTOPICS, 'topic_id='.$topic->topic_id, 'topic_slug');
                         $url = sp_build_url($forum_slug, $topic_slug, 0, 0);
                 }
         }
         return $url;
}

# ------------------------------------------------------------------
# sp_do_switch_canonical_url()
#
# Set canonical url if being switched to blog url
# ------------------------------------------------------------------
function sp_do_switch_canonical_url($url) {
         global $sfvars;
         if (!empty($sfvars['topicslug'])) {
                 $sfpostlinking = sp_get_option('sfpostlinking');
                 $topic = spdb_table(SFTOPICS, "topic_slug='".$sfvars['topicslug']."'", 'row');
                 # check for linked topic and pointing linke topic to blog post?
                if (!empty($topic) && $topic->blog_post_id && $sfpostlinking['sflinkurls'] == 3) {
                         $url = get_permalink($topic->blog_post_id);
                 }
         }
         return $url;
}

# ------------------------------------------------------------------
# sp_do_linking_topic_tool()
#
# Include a break link tool of appropriate and allowed
# ------------------------------------------------------------------
function sp_do_linking_topic_tool($topic, $forum, $page) {

         global $sfvars;
         $out='';

         if(sp_get_auth('break_linked_topics', $forum['forum_id']) && $topic['blog_post_id']) {
                 $out = '<div class="spForumToolsLinking">';
                 $out.= '<img class="spIcon" src="'.sp_find_icon(SPBLIMAGES, "sp_ToolsLink.png").'" alt="" title="" />';
                 $msg = esc_js(__('Are you sure you want to break this link?', 'sp-linking'));
                 $out.= '<a href="javascript: if(confirm(\''.$msg.'\')) {document.breaklink'.$topic['topic_id'].'.submit();}">'.__('Break Blog Post Link', 'sp-linking').'</a>';
                 $out.= '<form action="'.sp_build_url($forum['forum_slug'], $topic['topic_slug'], $page, 0).'" method="post" name="breaklink'.$topic['topic_id'].'">';
                 $out.= '<input type="hidden" name="linktopic" value="'.$topic['topic_id'].'" />';
                 $out.= '<input type="hidden" name="linkpost" value="'.$topic['blog_post_id'].'" />';
                 $out.= '</form>';
                 $out.= '</div>';
         }
         return $out;
}

# ------------------------------------------------------------------
# sp_do_linking_post_edit_form()
#
# Add option to post edit submit to update blog post if linked
# ------------------------------------------------------------------
function sp_do_linking_post_edit_form($blogPostId) {
         $editchecked = '';
         $out = '';
         $links = sp_blog_links_control('read', $blogPostId);
         if($links)
         {
                 if($links->syncedit) $editchecked = "checked='checked'";

                 $out.= "<input type='hidden' name='blogpostid' value='$blogPostId' />\n";
                 $out.= "<div style='max-width: 180px;margin: auto;'><p style='text-align:left;'><label for='blogpostedit'>".__('Update blog post', 'sp-linking').":</label>\n";
                 $out.= "<input type='checkbox' tabindex='4' id='blogpostedit' name='blogpostedit' $editchecked value='1' />\n";
                 $out.= "<br /><br /></p></div>";
         }
         return $out;
}

# ------------------------------------------------------------------
# sp_do_linking_update_blog_post()
#
# Update blog post after a linked topic post edit
# ------------------------------------------------------------------
function sp_do_linking_update_blog_post($newpost) {
         global $wpdb;
         $ID = sp_esc_int($newpost['blogpostid']);
         $postcontent = sp_filter_content_save($newpost['postcontent'], 'edit');
         spdb_query("UPDATE ".$wpdb->prefix."posts SET post_content = '$postcontent' WHERE ID = $ID");
}

function sp_do_linking_merge_forums($source, $target) {
         spdb_query("UPDATE ".SFLINKS." SET forum_id=$target WHERE forum_id=$source");
         $linkOpts = sp_get_option('sfpostlinking');
         if($linkOpts['sfautoforum'] == $source) {
                 $linkOpts['sfautoforum'] = $target;
                 sp_update_option('sfpostlinking', $linkOpts);
         }
}

?>
