<?php
/*
 Simple:Press
 Blog Linking plugin install/upgrade routine
 */

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_linking_do_install() {
         # Check if already exists - i.e, this is an upgrade
        $sfpostlinking = sp_get_option('sfpostlinking');
         if(empty($sfpostlinking)) {
                 # New Install
                # Create blog linking table
                $sql = "
                         CREATE TABLE IF NOT EXISTS ".SFLINKS." (
                                 id bigint(20) NOT NULL auto_increment,
                                 post_id bigint(20) default '0',
                                 forum_id bigint(20) default '0',
                                 topic_id bigint(20) default '0',
                                 syncedit smallint(1) default '0',
                                 PRIMARY KEY (id),
                                 KEY post_idx (post_id),
                                 KEY forum_idx (forum_id),
                                 KEY topic_idx (topic_id)
                         ) ENGINE=MyISAM ".spdb_charset().";";
                 spdb_query($sql);

                 # Add column and index to the topics table
                spdb_query("ALTER TABLE ".SFTOPICS. " ADD blog_post_id bigint(20) NOT NULL default 0");

                 # Create the options array
                $sfpostlinking = array();

                 $sfpostlinking['sflinkexcerpt']         = 1;
                 $sfpostlinking['sflinkwords']           = 100;
                 $sfpostlinking['sflinkblogtext']        = '%ICON% Join the forum discussion on this post';
                 $sfpostlinking['sflinkabove']           = false;
                 $sfpostlinking['sflinkcomments']        = 1;
                 $sfpostlinking['sfhideduplicate']       = true;
                 $sfpostlinking['sfpostcomment']         = false;
                 $sfpostlinking['sfkillcomment']         = false;
                 $sfpostlinking['sfeditcomment']         = false;
                 $sfpostlinking['sflinksingle']          = false;
                 $sfpostlinking['sfuseautolabel']        = true;
                 $sfpostlinking['sfautoupdate']          = true;
                 $sfpostlinking['sfautocreate']          = false;
                 $sfpostlinking['sfautoforum']           = '';
                 $sfpostlinking['sflinkurls']            = 1; # each get their own canonical url
                $sfpostlinking['posttypes']['post'] = true;
                 $sfpostlinking['posttypes']['page'] = true;

                 sp_add_option('sfpostlinking', $sfpostlinking);
         } else {
                 # Upgrade
                # Changes to V5.0.0 Only
                spdb_query("ALTER TABLE ".SFLINKS." MODIFY id bigint(20) auto_increment;");
                 spdb_query("ALTER TABLE ".SFLINKS." MODIFY forum_id bigint(20) default 0, MODIFY topic_id bigint(20) default 0, MODIFY post_id bigint(20) default 0;");
                 spdb_query("ALTER TABLE ".SFLINKS." ADD KEY post_idx (post_id), ADD KEY forum_idx (forum_id), ADD KEY topic_idx (topic_id);");

                 spdb_query("ALTER TABLE ".SFTOPICS." ADD KEY blog_post_idx (blog_post_id);");

                 $sfpostlinking = array();
                 $sfpostlinking = sp_get_option('sfpostlinking');
                 $sflinkposttype = array();
                 $sflinkposttype = sp_get_option('sflinkposttype');
                 if ($sflinkposttype) {
                         foreach($sflinkposttype as $key=>$value) {
                                 $sfpostlinking['posttypes'][$key] = $sfpostlinking[$value];
                         }
                 } else {
                 $sfpostlinking['posttypes']['post'] = true;
                 $sfpostlinking['posttypes']['page'] = true;               
                 }
                 sp_update_option('sfpostlinking', $sfpostlinking);
                 sp_delete_option('sflinkposttype');
         }

         # New items required by Version 5.0.0
    # add new permissions into the auths table
        sp_add_auth('create_linked_topics', __('Can create linked blog post and forum topics', 'sp-linking'), 1, 1, 1);
     sp_activate_auth('create_linked_topics');

         sp_add_auth('break_linked_topics', __('Can break link between blog posts and forum topics', 'sp-linking'), 1, 1, 1);
     sp_activate_auth('break_linked_topics');
}

?>
