<?php
/*
 Simple:Press Plugin Title: Blog Post Linking
 Version: 1.1
 Plugin URI: http://simple-press.com
 Description: Links Blog Posts and Comments to Forum Topics and Posts
 Author: Andy Staines & Steve Klasen
 Author URI: http://simple-press.com
 Simple:Press Versions: 5.0 and above
 */

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

include_once(SF_PLUGIN_DIR.'/forum/database/sp-db-management.php');

# ======================================
# CONSTANTS USED BY THIS PLUGIN
# ======================================
define('SFLINKS',               SF_PREFIX.'sflinks');
define('SPBLDIR',               SFPLUGINDIR.'blog-linking/');
define('SPBLLIB',               SFPLUGINDIR.'blog-linking/library/');
define('SPBLFORM',              SFPLUGINDIR.'blog-linking/forms/');
define('SPBLAHAH',              SFPLUGINDIR.'blog-linking/ahah/');
define('SPBLIMAGES',    SFPLUGINURL.'blog-linking/resources/images/');

# ======================================
# ACTIONS/FILTERS USED BY THUS PLUGIN
# ======================================
# Plugin and admin
add_action('sph_activate_blog-linking/sp-linking-plugin.php',   'sp_linking_install');
 add_action('sph_deactivate_blog-linking/sp-linking-plugin.php', 'sp_linking_deactivate');
 add_action('sph_uninstall_blog-linking/sp-linking-plugin.php',  'sp_linking_uninstall');
 add_filter('sph_plugins_active_buttons',                                                'sp_linking_uninstall_option', 10, 2);
 add_action('init',                                                                                              'sp_linking_localisation');
 add_action('sph_admin_menu',                                                                    'sp_linking_admin_menu');
 add_filter('sph_admin_help-admin-components',                                   'sp_linking_admin_help', 10, 3);
 add_filter('sph_perms_tooltips',                                                                'sp_linking_admin_tooltips', 10, 2);
 add_action('sph_merge_forums',                                                                  'sp_linking_merge_forums', 1, 2);

# Blog Post Link Processing
$sfpostlinking = sp_get_option('sfpostlinking');

 add_action('save_post',                                         'sp_linking_save_blog_link');
 add_action('draft_to_publish',                          'sp_linking_publish_blog_link', 10, 1);
 add_action('future_to_publish',                         'sp_linking_publish_blog_link', 10, 1);
 add_action('pending_to_publish',                        'sp_linking_publish_blog_link', 10, 1);
 add_action('new_to_publish',                            'sp_linking_publish_blog_link', 10, 1);
 add_action('edit_post',                                         'sp_linking_update_blog_link');
 add_action('delete_post',                                       'sp_linking_delete_blog_link');
 add_action('sph_setup_forum',                           'sp_linking_check_delete_action');

if ($sfpostlinking['sfuseautolabel']) {
         add_filter('the_content',                               'sp_linking_show_blog_link');
         add_filter('the excerpt',                               'sp_linking_show_blog_link');
}

if ($sfpostlinking['sflinkcomments'] == 2 || $sfpostlinking['sflinkcomments'] == 3) {
         add_filter('comments_array',                    'sp_linking_topic_as_comments');
         add_filter('get_avatar_comment_types',  'sp_linking_add_comment_type');
         add_filter('edit_comment_link',                 'sp_linking_remove_edit_comment_link', 1, 2);
}

if (isset($sfpostlinking['sfpostcomment']) && $sfpostlinking['sfpostcomment'] == true) {
         add_action('wp_set_comment_status',     'sp_linking_process_new_comment', 10, 2);
         add_action('comment_post',                              'sp_linking_process_new_comment', 10, 2);
         add_action('edit_comment',                              'sp_linking_update_comment_post');
}

 add_action('admin_init',                                        'sp_linking_blog_link_form');
 add_filter('manage_posts_columns',                      'sp_linking_add_admin_link_column');
 add_filter('manage_pages_columns',                      'sp_linking_add_admin_link_column');
 add_action('manage_posts_custom_column',        'sp_linking_show_admin_link_column', 10, 2);
 add_action('manage_pages_custom_column',        'sp_linking_show_admin_link_column', 10, 2);

 add_action('sph_ahah_handler_linking',          'sp_linking_break_link_ahah');
 add_action('sph_ahah_handler_categories',       'sp_linking_categories_ahah');

# Forum wide support
add_action('sph_move_post_form',                        'sp_linking_move_post_form', 1, 2);
 add_action('sph_move_post',                             'sp_linking_move_post', 1, 3);
 add_action('sph_move_topic',                            'sp_linking_move_topic', 1, 3);
 add_filter('sph_forumview_query',                       'sp_linking_forumview_query');
 add_filter('sph_forumview_topic_records',       'sp_linking_forumview_records', 10, 2);
 add_filter('sph_topicview_query',                       'sp_linking_forumview_query');
 add_filter('sph_topicview_topic_record',        'sp_linking_forumview_records', 10, 2);
 add_action('sph_topic_delete',                          'sp_linking_delete_topic');
 add_filter('sph_topic_editor_display_options',  'sp_linking_check_topic_option', 1);
 add_filter('sph_topic_options_add',             'sp_linking_add_topic_option', 1, 2);

# Make new blog post from forum topic
add_filter('sph_new_forum_post',                        'sp_linking_collect_link_data');
 add_action('sph_post_create',                           'sp_linking_create_blog_post');

# URL handling
add_action('sph_blog_support_start',            'sp_linking_canonical_url', 1, 1);
 add_filter('sph_aioseo_canonical_url',          'sp_linking_aioseo_caninical_url', 1, 2);
 add_filter('sph_canonical_url',                         'sp_linking_switch_canionical_url');

# Forum Display Items
add_filter('sph_TopicIndexStatusIconsLast',     'sp_linking_add_status_icon');

# Topic Tool
add_filter('sph_add_topic_tool',                        'sp_linking_topic_tool', 10, 4);
 add_action('sph_setup_forum',                           'sp_linking_break_listen');

# Topic Post Edit
add_filter('sph_post_edit_form_controls_above', 'sp_linking_post_edit_form', 1, 3);
 add_action('sph_post_edit_after_save',          'sp_linking_update_blog_post');

# ======================================
# BLOG POST LINING PROCESSING
# ======================================

# ----------------------------------------------
# Save, publish, update and delete
# blog posts
# ----------------------------------------------
function sp_linking_save_blog_link($postid) {
         include_once(SPBLLIB.'sp-linking-blog.php');
         $postid = (int) $postid;
         sp_save_blog_link($postid);
}

function sp_linking_publish_blog_link($post) {
         include_once(SPBLLIB.'sp-linking-blog.php');
         sp_publish_blog_link($post);
}

function sp_linking_update_blog_link($postid) {
         include_once(SPBLLIB.'sp-linking-blog.php');
         sp_update_blog_link($postid);
}

function sp_linking_delete_blog_link($postid) {
         include_once(SPBLLIB.'sp-linking-blog.php');
         sp_delete_blog_link($postid);
}

function sp_linking_check_delete_action() {
         include_once(SPBLLIB.'sp-linking-support.php');
         if (isset($_POST['linkbreak'])) {
                 sp_break_blog_link(sp_esc_int($_POST['linkbreak']), sp_esc_int($_POST['blogpost']));
         }
}

# ----------------------------------------------
# Display the blog link itself in blog post
# ----------------------------------------------
function sp_linking_show_blog_link($content) {
         include_once(SPBLLIB.'sp-linking-blog.php');
         return sp_show_blog_link($content);
}

# ----------------------------------------------
# Manipulation of comments
# ----------------------------------------------
function sp_linking_topic_as_comments($comments) {
         include_once(SPBLLIB.'sp-linking-comments.php');
         return sp_topic_as_comments($comments);
}

function sp_linking_add_comment_type($list) {
         include_once(SPBLLIB.'sp-linking-comments.php');
         return sp_add_comment_type($list);
}

function sp_linking_remove_edit_comment_link($link, $id) {
         include_once(SPBLLIB.'sp-linking-comments.php');
         $link = sp_remove_edit_comment_link($link, $id);
         return $link;
}

function sp_linking_process_new_comment($cid, $commentstatus) {
         include_once(SPBLLIB.'sp-linking-comments.php');
         sp_process_new_comment($cid, $commentstatus);
}

function sp_linking_update_comment_post($cid) {
         include_once(SPBLLIB.'sp-linking-comments.php');
         sp_update_comment_post($cid);
}

# ----------------------------------------------
# render the blog post linking form in edit post
# ----------------------------------------------
function sp_linking_blog_link_form() {
         include_once(SPBLFORM.'sp-linking-form.php');
         sp_blog_link_form();
}

# ----------------------------------------------
# Add blog linking info to post and page lists
# ----------------------------------------------
function sp_linking_add_admin_link_column($defaults) {
         include_once(SPBLLIB.'sp-linking-blog.php');
         return sp_add_admin_link_column($defaults);
}

function sp_linking_show_admin_link_column($column, $postid) {
         include_once(SPBLLIB.'sp-linking-blog.php');
         sp_show_admin_link_column($column, $postid);
}

# ----------------------------------------------
# Ahah call to breaklink/categories: set handler
# ----------------------------------------------
function sp_linking_break_link_ahah() {
         include_once(SPBLAHAH.'sp-ahah-linking.php');
}

function sp_linking_categories_ahah() {
         include_once(SPBLAHAH.'sp-ahah-categories.php');
}

# ----------------------------------------------
# Prepare data when new topic is created
# ----------------------------------------------
function sp_linking_collect_link_data($postdata) {
         include_once(SPBLLIB.'sp-linking-forum.php');
         return sp_do_collect_link_data($postdata);
}

function sp_linking_create_blog_post($postdata) {
         include_once(SPBLLIB.'sp-linking-forum.php');
         sp_do_create_blog_post($postdata);
}

# ======================================
# PLUGIN AND ADMIN
# ======================================

# ----------------------------------------------
# Run Install Script on Activation action
# ----------------------------------------------
function sp_linking_install() {
         include_once(SPBLDIR.'sp-linking-install.php');
         sp_linking_do_install();
}

# ----------------------------------------------
# Run Deactivate Script on Deactivation action
# ----------------------------------------------
function sp_linking_deactivate() {
         include_once(SPBLDIR.'sp-linking-uninstall.php');
         sp_linking_do_deactivate();
}

# ----------------------------------------------
# Run Uninstall Script on Uninstall action
# ----------------------------------------------
function sp_linking_uninstall() {
         include_once(SPBLDIR.'sp-linking-uninstall.php');
         sp_linking_do_uninstall();
}

# ------------------------------------------------------
# Add the 'Uninstall' and 'Options' link to plugins list
# ------------------------------------------------------
function sp_linking_uninstall_option($actionlink, $plugin) {
         if ($plugin == 'blog-linking/sp-linking-plugin.php') {
                 $url = SFADMINPLUGINS.'&amp;action=uninstall&amp;plugin='.$plugin.'&amp;sfnonce='.wp_create_nonce('forum-adminform_plugins');
                 $actionlink.= "&nbsp;&nbsp;<a href='".$url."' title='".__("Uninstall this plugin", "sp-linking")."'>".__("Uninstall", "sp-linking")."</a>";

                 $url = SFADMINCOMPONENTS.'&amp;tab=plugin&amp;admin=sp_linking_admin_form&amp;save=sp_linking_admin_save&amp;form=1';
                 $actionlink.= "&nbsp;&nbsp;<a href='".$url."' title='".__("Options", "sp-linking")."'>".__("Options", "sp-linking")."</a>";
         }
         return $actionlink;
}

# ------------------------------------------------------
# Set up language file
# ------------------------------------------------------
function sp_linking_localisation() {
         sp_plugin_localisation('sp-linking');
}

# ----------------------------------------------
# Add permission tooltips to permissions panels
# ----------------------------------------------
function sp_linking_admin_tooltips($tips, $t) {
     $tips['create_linked_topics'] = $t.__('Can create linked blog post and forum topics', 'sp-linking');
     $tips['break_linked_topics'] = $t.__('Can break link between blog posts and forum topics', 'sp-linking');
     return $tips;
}

# ----------------------------------------------
# Add Linking Admin Panel to Components
# ----------------------------------------------
function sp_linking_admin_menu() {
         $subpanels = array(
                 __("Blog Post Linking", "sp-linking") => array('admin' => 'sp_linking_admin_form', 'save' => 'sp_linking_admin_save', 'form' => 1, 'id' => '')
         );
         sp_add_admin_subpanel('components', $subpanels);
}

function sp_linking_merge_forums($source, $target) {
         include_once(SPBLLIB.'sp-linking-support.php');
         sp_do_linking_merge_forums($source, $target);
}

# ----------------------------------------------
# Load the Linking Options Admin Form
# ----------------------------------------------
function sp_linking_admin_form() {
         include_once(SPBLDIR.'admin/spa-components-linking-form.php');
         spa_components_linking_options();
}

# ----------------------------------------------
# Save the Linking Options Admin Form Data
# ----------------------------------------------
function sp_linking_admin_save() {
         include_once(SPBLDIR.'admin/spa-components-linking-save.php');
         return spa_linking_options_save();
}

# ----------------------------------------------
# Action the Blog Linking admin panel popup help
# ----------------------------------------------
function sp_linking_admin_help($file, $tag, $lang) {
     if ($tag == '[post-linking]' ||
         $tag == '[link-urls]' ||
         $tag == '[link-text-display]' ||
         $tag == '[show-as-comments]' ||
         $tag == '[posts-from-comments]') $file = SPBLDIR.'admin/spa-linking-admin-help.'.$lang;
     return $file;
}

# ----------------------------------------------
# Move Post Management
# ----------------------------------------------
function sp_linking_move_post_form($postid, $topicid) {
         include_once(SPBLLIB.'sp-linking-support.php');
         sp_do_move_post_form($postid, $topicid);
}

function sp_linking_move_post($oldtopicid, $newtopicid, $newforumid) {
         include_once(SPBLLIB.'sp-linking-support.php');
         sp_do_move_post($oldtopicid, $newtopicid, $newforumid);
}

# ----------------------------------------------
# Move Topic Management
# ----------------------------------------------
function sp_linking_move_topic($topicid, $oldforumid, $newforumid) {
         include_once(SPBLLIB.'sp-linking-support.php');
         sp_relink_topic($topicid, $topicid, $newforumid);
}

# ----------------------------------------------
# Add blog_post_id to forum view query/class
# ----------------------------------------------
function sp_linking_forumview_query($query) {
         $query->fields.= ', blog_post_id';
         return $query;
}

function sp_linking_forumview_records($data, $record) {
         $data->blog_post_id = $record->blog_post_id;
         return $data;
}

# ----------------------------------------------
# Delete blog link from a deleted topic
# ----------------------------------------------
function sp_linking_delete_topic($posts) {
         if ($posts) {
         $postid = (is_object($posts)) ? $posts->post_id : $posts[0]->post_id;
                 sp_blog_links_control('delete', $post_id);
         }
}

# ----------------------------------------------
# check if link option needed on add topic form
# ----------------------------------------------
function sp_linking_check_topic_option($display) {
         global $spThisForum;
         if (sp_get_auth('create_linked_topics', $spThisForum->forum_id) && current_user_can('publish_posts')) $display['options'] = true;
         return $display;
}

# ----------------------------------------------
# Add link option to form add topic form
# ----------------------------------------------
function sp_linking_add_topic_option($optionsBox, $spThisForum) {
         include_once(SPBLLIB.'sp-linking-support.php');
         return sp_do_add_topic_option($optionsBox, $spThisForum);
}

# ----------------------------------------------
# Canonical URL handling
# ----------------------------------------------
function sp_linking_canonical_url($wpPost) {
         include_once(SPBLLIB.'sp-linking-support.php');
         sp_do_canonical_url($wpPost);
}

function sp_linking_aioseo_caninical_url($url, $wpPost) {
         include_once(SPBLLIB.'sp-linking-support.php');
         return sp_do_aioseo_canonical_url($url, $wpPost);
}

function sp_linking_switch_canionical_url($url) {
         include_once(SPBLLIB.'sp-linking-support.php');
         return sp_do_switch_canonical_url($url);
}

# ----------------------------------------------
# Add blog link status icon to forum view
# ----------------------------------------------
function sp_linking_add_status_icon($content) {
         global $spThisTopic;
         $out = '';
         if($spThisTopic->blog_post_id) {
                 $icon = sp_find_icon(SPBLIMAGES, "sp_BlogLink.png");
                 $toolTip = esc_attr(__('This topic is linked to a blog post', 'sp-linking'));
                 $out = "<img class='vtip' src='$icon' title='$toolTip' alt='' />\n";
         }
         return $content.$out;
}

# ======================================
# TEMPLATE TAGS
# ======================================

# Template function tags
# ----------------------------------------------
# Display the blog link on the topic view
# ----------------------------------------------
function sp_TopicHeaderShowBlogLink($args='', $label='', $toolTip='') {
         include_once(SPBLDIR.'template-tags/sp-linking-show-link.php');
         sp_do_TopicHeaderShowBlogLink($args, $label, $toolTip);
}

#  Blog/Site tags
function spBlogTopicLink($postid, $show_img=true) {
         include_once(SPBLLIB.'sp-linking-blog.php');
         include_once(SPBLDIR.'template-tags/sp-linking-blog-tags.php');
         spBlogTopicLinkTag($postid, $show_img);
}

function spLinkedTopicPostCount() {
         include_once(SPBLLIB.'sp-linking-blog.php');
         include_once(SPBLDIR.'template-tags/sp-linking-blog-tags.php');
         spLinkedTopicPostCountTag();
}

function spFirstTopicPostLink($blogpostid, $linktext) {
         include_once(SPBLDIR.'template-tags/sp-linking-blog-tags.php');
         spFirstTopicPostLinkTag($blogpostid, $linktext);
}

function spLastTopicPostLink($blogpostid, $linktext) {
         include_once(SPBLDIR.'template-tags/sp-linking-blog-tags.php');
         spLastTopicPostLinkTag($blogpostid, $linktext);
}

function spCommentsNumber($no_comment="0 Comments", $one_comment="1 Comment", $many_comment="% Comments", $blogcomments=false, $postid=0) {
         include_once(SPBLLIB.'sp-linking-blog.php');
         include_once(SPBLDIR.'template-tags/sp-linking-comment-tags.php');
         spCommentsNumberTag($no_comment, $one_comment, $many_comment, $blogcomments, $postid);
}

# ----------------------------------------------
# Break Link - topic edit tool
# ----------------------------------------------
function sp_linking_topic_tool($out, $topic, $forum, $page) {
         include_once(SPBLLIB.'sp-linking-support.php');
         return $out.sp_do_linking_topic_tool($topic, $forum, $page);
}

function sp_linking_break_listen() {
         if (isset($_POST['linktopic'])) {
                 include_once(SPBLLIB.'sp-linking-support.php');
                 sp_break_blog_link($_POST['linktopic'], $_POST['linkpost']);
                 sp_notify(0, __('Link Broken', 'sp-linking'));
         }
}

# ----------------------------------------------
# Post topic edit
# ----------------------------------------------
function sp_linking_post_edit_form($content, $postid, $topic) {
         $out='';
         if($topic->blog_post_id && $topic->posts[$postid]->post_index ==1) {
                 include_once(SPBLLIB.'sp-linking-support.php');
                 $out = sp_do_linking_post_edit_form($topic->blog_post_id);
         }
         return $content.$out;
}

function sp_linking_update_blog_post($newpost) {
         if(isset($_POST['blogpostid']) && isset($_POST['blogpostedit'])) {
                 include_once(SPBLLIB.'sp-linking-support.php');
                 $newpost['blogpostid'] = $_POST['blogpostid'];
                 sp_do_linking_update_blog_post($newpost);
         }
}

# ------------------------------------------------------------------
# sp_blog_links_control()
#
# In main pliugin file because everythign uses it
#
# General postmeta handling for blog linking
#       $action         save, update, read or delete
#       $postid         WP Post id of the link
#       $forumid        ID of target forum
#       $topicid        ID of target topic
#       $syncedit       Optional - sync edit flag
# ------------------------------------------------------------------
function sp_blog_links_control($action, $postid, $forumid=0, $topicid=0, $syncedit=0) {
         if (!isset($postid)) return;
         switch($action) {

                 case 'save':
                         # check if there already...
                        $result = spdb_table(SFLINKS, "post_id=$postid", 'row');
                         if ($result) {
                                 $sql = 'UPDATE '.SFLINKS." SET forum_id=$forumid, topic_id=$topicid, syncedit=$syncedit WHERE post_id=$postid";
                                 spdb_query($sql);
                         } else {
                                 $sql = 'INSERT INTO '.SFLINKS." (post_id, forum_id, topic_id, syncedit) VALUES ($postid, $forumid, $topicid, $syncedit)";
                                 spdb_query($sql);
                         }
                         break;
                 case 'update':
                         $sql = 'UPDATE '.SFLINKS." SET forum_id=$forumid, topic_id=$topicid, syncedit=$syncedit WHERE post_id=$postid";
                         spdb_query($sql);
                         break;
                 case 'read':
                         return spdb_table(SFLINKS, "post_id=$postid", 'row');
                         break;
                 case 'delete':
                         $sql = 'DELETE FROM '.SFLINKS." WHERE post_id=$postid";
                         return(spdb_select('row', $sql));
                         break;
         }
}

?>
