<?php
/*
 Simple:Press
 Template Tag(s) - Blog Linking Specific
 $LastChangedDate: 2012-04-05 14:55:10 -0500 (Thu, 05 Apr 2012) $
 $Rev: 8267 $
 */

if(preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) {
         die('Access Denied');
}

/*      =====================================================================================

         spBlogTopicLink($postid, $show_img)

         Allows display of forum topic link for blog linked post outside of the post content

         parameters:

                 $postid                 id of the blog post                                     number                  required
                 $show_img               display blog linked image                       true/fase               default true
         ===================================================================================*/

function spBlogTopicLinkTag($postid, $show_img) {
     $postid = sp_esc_int($postid);
     if (empty($postid)) return;
     $links = sp_blog_links_control('read', $postid);

     if($links) sp_forum_api_support();
     if ($links && sp_get_auth('view_forum', $links->forum_id)) {
                 echo sp_transform_bloglink_label($postid, $links, $show_img);
         }
}

/*      =====================================================================================

         spLinkedTopicPostCountTag()

         displays the number of topic posts in the currently displayed linked blog post

         parameters: None

         For use with in the wp loop

         ===================================================================================*/

function spLinkedTopicPostCountTag() {
         global $wp_query;
         $result = '';
         $postid = $wp_query->post->ID;
         $links = sf_blog_links_control('read', $postid);
     if($links) sp_forum_api_support();
     if ($links && sp_get_auth('view_forum', $links->forum_id)) {
                 # link found for this post
                $result = sp_get_posts_count_in_linked_topic($links->topic_id, false);
                 echo $result;
         }
}

/*      =====================================================================================

         spFirstTopicPostLinkTag($blog_post_id, $link_text

         Creates a link to the first topic post in a blog post/topic linked thread

         parameters:

                 $blog_post_id           The ID pof the blog post ($post->ID in Post Loop)
                 $link text                      What text to display as the link
         ===================================================================================*/

function spFirstTopicPostLinkTag($blogpostid, $linktext) {
         $topiclink='';
     $blogpostid = sp_esc_int($blogpostid);
         if($blogpostid) {
                 $links = sp_blog_links_control('read', $blogpostid);
             if($links) sp_forum_api_support();
             if ($links && sp_get_auth('view_forum', $links->forum_id)) {
                         $postid = spdb_table(SFPOSTS, "topic_id=".$links->topic_id." AND post_index=1", 'post_id');
                         $topiclink = '<a href="'.sp_build_url(spdb_table(SFFORUMS, "forum_id=".$links->forum_id, 'forum_slug'), spdb_table(SFTOPICS, "topic_id=".$links->topic_id, 'topic_slug'), 1, $postid, 1).'">'.$linktext.'</a>';
                         echo $topiclink;
                 }
         }
}

/*      =====================================================================================

         spLastTopicPostLinkTag($blog_post_id, $link_text

         Creates a link to the last topic post in a blog post/topic linked thread

         parameters:

                 $blog_post_id           The ID pof the blog post ($post->ID in Post Loop)
                 $link text                      What text to display as the link
         ===================================================================================*/

function spLastTopicPostLinkTag($blogpostid, $linktext) {
         $topiclink='';
     $blogpostid = sp_esc_int($blogpostid);
         if($blogpostid) {
                 $links = sp_blog_links_control('read', $blogpostid);
             if($links) sp_forum_api_support();
             if ($links && sp_get_auth('view_forum', $links->forum_id)) {
                         $postid = spdb_table(SFPOSTS, "topic_id=".$links->topic_id, 'post_id', 'post_index DESC', '1');
                         $topiclink = '<a href="'.sp_build_url(spdb_table(SFFORUMS, "forum_id=".$links->forum_id, 'forum_slug'), spdb_table(SFTOPICS, "topic_id=".$links->topic_id, 'topic_slug'), 1, $postid, 1).'">'.$linktext.'</a>';
                         echo $topiclink;
                 }
         }
}

?>
