<?php
/*
 Simple:Press
 Blog Linking - Forum side support routines
 $LastChangedDate: 2012-02-15 18:45:41 -0600 (Wed, 15 Feb 2012) $
 $Rev: 7952 $
 */

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

# --------------------------------------------------------------------------------------
#
#       sp_TopicHeaderShowBlogLink()
#       Display Topic View
#       Scope:  Topic Header Level
#
#       class:          CSS styling class
#       icon:           name of optional icon to use as button
#       iconClass:
#
#       label:          Text to display on button
#       toolTip:        For the tooltip title attribute
#
# --------------------------------------------------------------------------------------
function sp_do_TopicHeaderShowBlogLink($args='', $label='', $toolTip='') {
         global $spThisTopic;

         if(!$spThisTopic->blog_post_id) return;

         $defs = array('tagId'           => 'spTopicHeaderShowBlogLink',
                                   'tagClass'    => 'spButton',
                                   'icon'                => 'sp_BlogLink.png',
                                   'iconClass'   => 'spIcon',
                                   'echo'                => 1,
                                   'get'                 => 0
                                   );
         $a = wp_parse_args($args, $defs);
         $a = apply_filters('sph_TopicHeaderShowBlogLink_args', $a);
         extract($a, EXTR_SKIP);

         # sanitize before use
        $tagId          = esc_attr($tagId);
         $tagClass       = esc_attr($tagClass);
         $icon           = sp_find_icon(SPBLIMAGES, sanitize_file_name($icon));
         $iconClass      = esc_attr($iconClass);
         $toolTip        = sp_filter_title_display($toolTip);
         $label          = esc_attr($label);
         $echo           = (int) $echo;
         $get            = (int) $get;

         if ($get) return $label;

         $out = "<a class='$tagClass vtip' id='$tagId' title='$toolTip' rel='nofollow' href='".get_permalink($spThisTopic->blog_post_id)."'>";
         if (!empty($icon)) $out.= "<img class='$iconClass' src='".$icon."' alt=''/>";
         if (!empty($label)) $out.= $label;
         $out.= "</a>\n";
         $out = apply_filters('sph_TopicHeaderShowBlogLink', $out, $a);

         if ($echo) {
                 echo $out;
         } else {
                 return $out;
         }
}

?>
